#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include <alloc.h>
#include <string.h>
#include <float.h>
#include <time.h>

/* Disparidad de fijacin

Alvaro Pons
depto. de Optica
email: Alvaro.Pons@uv.es
*/


void modopantalla(char m);
void cambia(int color,char r,char g,char b);
void ponpunto(int x,int y,int c);
void lineax(int y,int l, int c);
void lineay(int x,int y,int l, int c);
void cuadrado(int x0, int y0, int l,int c);
void circulo(int x, int y, int r, int color);


void pausa (int n);
void espera(void);
int redond (float x);
void buf(void);
void ayuda(int ref,int proc);
int tiempo=100;

void main ()
	{
	int i,j,k;
	float n,nn;
	char ch;
	char cs,ci;

	int control=0;

        cs=ci=150;
	nn=1.258963*sin(3.14159265);

	printf("Para igualar la posicin de las dos lneas\n");
	printf("(a)-(s) lnea superior\n");
	printf("(z)-(x) lnea inferior\n");
	printf("(q) finalizar\n");
	printf("Pulsa cualquier tecla...");
	getch();


	modopantalla(0x13);
	cambia(1,63,63,63);
	cambia(2,0,0,0);
	cambia(3,63,0,0);
	for(i=1;i<60;i++)
		{
		lineax(i,300,1);
		}
	for(i=60;i<120;i++)
		{
		lineax(i,300,2);
		}
	for(i=120;i<180;i++)
		{
		lineax(i,300,1);
		}


	circulo(150,90,25,1);
	circulo(150,90,24,1);
	circulo(150,90,23,1);
	circulo(150,90,22,1);
	circulo(150,90,21,1);
	for(i=140;i<160;i++)
		{
                cambia(i,63,63,63);
		cambia(i-100,63,63,63);

		lineay(i,1,59,i);
		lineay(i,120,59,i-100);

		}

	while(control<100)
		{
		ch=getch();
		if (ch=='a')
			{
			cs=cs--;
			}
		if (ch=='s')
			{
			cs=cs++;
			}
		if (ch=='z')
			{
			ci=ci--;
			}
		if (ch=='x')
			{
			ci=ci++;
			}
		cambia(cs,63,0,0);
		cambia(cs+1,63,63,63);
		cambia(cs-1,63,63,63);
		cambia(ci-100,0,63,63);
		cambia(ci+1-100,63,63,63);
		cambia(ci-1-100,63,63,63);
		if (ch=='q')
			{
			control=100;}
		}

	modopantalla(0x03);
	printf("Diferencia: %d pixeles",abs(abs(cs)-abs(ci)));
	getch();
	}













int redond (float x)
	{
	/*llamada por calculan;redondea decimales hacia el entero ms cercano*/

	int resul;
	float min, sup;
	sup=ceil(x);
	min=floor(x);
		if (x>(min+sup)/2) resul=(int)sup;
		else resul=(int)min;

	return (resul);
	}


float divf(int x,int y)
      {
      float xf,yf,res;

      xf=(float)x;
      yf=(float)y;

      res=(float)xf/yf;
      return(res);
      }

void buf(void)
{
	struct REGPACK jj;
	jj.r_ax=0x0100;
	intr(0x16,&jj);
	while(!(jj.r_flags & 0x0040))
	{
		jj.r_ax=0x0000;
		intr(0x16,&jj);
		jj.r_ax=0x0100;
		intr(0x16,&jj);
	}
}

void modopantalla(char m)
	{
	 _AH=0;
	 _AL=m;
	 geninterrupt(0x10);
	}

void cambia(int color,char r,char g,char b)
	{

		_AH=0x10;
		_AL=0x10;
		_BX=color;
		_DH=(char)r;
		_CH=(char)g;
		_CL=(char)b;
		geninterrupt(0x10);

	 }

void ponpunto(int x,int y,int c)
	{
	 _AH=0xc;
	 _AL=(char)c;
	 _BH=0;
	 _CX=x;
	 _DX=y;
	 geninterrupt(0x10);
	 }

char leeteclado()
	{
	char c;

	while((c=getch())==' ');
	return(c);
	}



void cuadrado(int x0, int y0, int l,int c)
	{
	int i,j;
	int lx,ly;

	if ((y0+l)>199) ly=199-y0;
	    else ly=l;
	if ((x0+l)>319) lx=319-x0;
	    else lx=l;

	for (i=0;i<ly;i++)
		for (j=0;j<lx;j++)
			{
			ponpunto(x0+j,y0+i,c);
			}
	}



void lineax(int y,int l, int c)
	{
	int i;
	   for (i=0;i<l;i++)
		    ponpunto(i,y,c);
	}

void lineay(int x,int y,int l, int c)
	{
	int i;
	   for (i=0;i<l;i++)
		    ponpunto(x,y+i,c);
	}


void espera (void)
	{
	int c;

	c=getch();
	while (c==' ');
	}





void circulo(int x, int y, int r, int color)
	{
	float radio,angulo,a;
	int i;
	float xf,yf;
	int xi,yi;
	float pi=3.14159265;
	radio=(float)r;

	for(i=1;i<90;i++)
		{
		a=i*1.00000;
		angulo=a*3.14159265/180;
		xf=radio*cos(angulo);
		yf=radio*sin(angulo);
		xi=(int)(xf);
		yi=(int)(yf);
		ponpunto(x+xi,y-yi,color);
		ponpunto(x-xi,y+yi,color);
		ponpunto(x-xi,y-yi,color);
		ponpunto(x+xi,y+yi,color);
		}
	}